import SocketIO from "socket.io";
import type { Server as ServerBase } from "@react-fullstack/fullstack/server";
interface Props {
    /**
     * The port the socket will run on.
     */
    port: number;
    /**
     * The server react app
     */
    children: () => JSX.Element;
    /**
     * share one app across all clients.
     */
    singleInstance?: boolean;
    /**
     * socket.io server options, note: must be passed with the first component mount, updating this prop will have no effect.
     * Note: cors header does not default to "*"
     */
    socketOptions?: Partial<SocketIO.ServerOptions>;
}
declare function createSocketServer(Server: typeof ServerBase): (props: Props) => JSX.Element;
export { createSocketServer };
