"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSocketServer = void 0;
const react_1 = __importStar(require("react"));
const socket_io_1 = __importDefault(require("socket.io"));
// @ts-ignore
const eiows_1 = require("eiows");
function SocketServer(props) {
    const { ServerBase } = props;
    const serverRef = (0, react_1.useRef)();
    if (!serverRef.current) {
        const server = new socket_io_1.default.Server(props.socketOptions, {
            wsEngine: eiows_1.Server,
        });
        server.setMaxListeners(Infinity);
        server.on("connection", (socket) => {
            socket.setMaxListeners(Infinity);
        });
        server.listen(props.port);
        serverRef.current = server;
    }
    const server = serverRef.current;
    (0, react_1.useEffect)(() => {
        return () => {
            if (server)
                server.close();
        };
    }, []);
    const getProps = (0, react_1.useCallback)(() => {
        const { children, singleInstance } = props;
        return {
            transport: {
                on: (event, callback) => {
                    if (event === "connection") {
                        server.on(event, callback);
                    }
                },
                emit: (event, ...args) => {
                    server.sockets.emit(event, ...args);
                },
                off: (event, callback) => {
                    server.sockets.removeListener(event, callback);
                    if (event === "connection") {
                        server.off(event, callback);
                    }
                },
            },
            singleInstance,
            children,
        };
    }, [props.children, props.singleInstance]);
    return react_1.default.createElement(ServerBase, Object.assign({}, getProps()));
}
function createSocketServer(Server) {
    return (props) => react_1.default.createElement(SocketServer, Object.assign({}, props, { ServerBase: Server }));
}
exports.createSocketServer = createSocketServer;
//# sourceMappingURL=index.js.map